interface Instantiable<T, P extends Array<any>> {
    new (...args: P): T;
}
declare type Abstract<T> = Function & {
    prototype: T;
};
declare type Class<T> = Instantiable<T, any> | Abstract<T>;
export declare type LifetimeScope = "permanent" | "transient";
export declare class Container {
    private readonly resolvables;
    private readonly values;
    register<T, P extends Array<any>>(type: Class<T> | string, implementedBy: Instantiable<T, P>, lifetimeScope: LifetimeScope, constructorParameters?: P): void;
    registerValue<T>(key: Class<T> | string, value: T): void;
    resolve<T>(key: Class<T> | string): T;
    getResolver(): <T>(key: Class<T> | string) => T;
    private resolveTransient;
    private resolvePermanent;
    private getKeyName;
}
export declare const globalContainer: Container;
export declare const globalResolve: <T>(key: string | Instantiable<T, any> | Abstract<T>) => T;
export {};
